//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#include "PLCU.h"
#pragma hdrstop


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  WarpBoxFocus = true;
  Warp = 0;
  FormGNU = new TFormGNU(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EditObjectSpeedChange(TObject *Sender)
{
  if(WarpBoxFocus == true)
  {
    if(CheckBoxHalfSpeed->Checked == true)
      EditSpeedLY->Text = AnsiString(EditObjectSpeed->Text.ToIntDef(0) *
                                     EditObjectSpeed->Text.ToIntDef(0) / 2);
    else
      EditSpeedLY->Text = AnsiString(EditObjectSpeed->Text.ToIntDef(0) *
                                     EditObjectSpeed->Text.ToIntDef(0));
  }

  DistanceCalc(this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditSpeedLYChange(TObject *Sender)
{


  if(CheckBoxHalfSpeed->Checked == false)
    Warp = sqrt(EditSpeedLY->Text.ToInt());
  else
    Warp = sqrt(EditSpeedLY->Text.ToInt() * 2);

//  WarpBoxFocus = false;

  if(floor(Warp + 0.99999) != floor(Warp))
  {
    EditObjectSpeedCover->Text = "";
    EditObjectSpeedCover->Visible = true;
    EditObjectSpeed->Visible = false;
  }
  else
  {
    EditObjectSpeedCover->Text = "";
    EditObjectSpeedCover->Visible = false;
    EditObjectSpeed->Visible = true;
    EditObjectSpeed->Text = AnsiString(int(Warp));
    WarpBoxFocus = true;
  }

  DistanceCalc(this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpDown5Click(TObject *Sender, TUDBtnType Button)
{
  WarpBoxFocus = true;
  EditObjectSpeedCover->Text = "";
  EditObjectSpeedCover->Visible = false;
  EditObjectSpeed->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditObjectSpeedCoverChange(TObject *Sender)
{
  EditObjectSpeedCover->Visible = false;
  EditObjectSpeed->Visible = true;
  WarpBoxFocus = true;
  EditObjectSpeed->SetFocus();
  EditObjectSpeedChange(this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBoxHalfSpeedClick(TObject *Sender)
{
  EditObjectSpeedChange(this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DistanceCalc(TObject *Sender)
{
  int DistanceX;
  int DistanceY;
  int StartX;
  int StartY;
  int ModX;
  int ModY;

  DistanceX = EditEndX->Text.ToIntDef(0) - EditStartX->Text.ToIntDef(0);
  DistanceY = EditEndY->Text.ToIntDef(0) - EditStartY->Text.ToIntDef(0);
  Distance = sqrt(DistanceY*DistanceY + DistanceX*DistanceX);

  LabelDistance->Caption = AnsiString(floor(Distance));

  if(RadioButton1->Checked == true)
  {
    StartX = EditStartX->Text.ToIntDef(0);
    StartY = EditStartY->Text.ToIntDef(0);
  }
  else
  {
    StartX = EditEndX->Text.ToIntDef(0);
    StartY = EditEndY->Text.ToIntDef(0);
  }

  ModX = 0;
  ModY = 0;

  if(Distance != 0)
  {
    for(int i=0;i<EditTime->Text.ToIntDef(0);i++)
    {
      DistanceX = (EditEndX->Text.ToIntDef(0)) - (EditStartX->Text.ToIntDef(0) + ModX);
      DistanceY = (EditEndY->Text.ToIntDef(0)) - (EditStartY->Text.ToIntDef(0) + ModY);
      Distance = sqrt(DistanceY*DistanceY + DistanceX*DistanceX);

      ModX = ModX + floor(DistanceX * (EditSpeedLY->Text.ToIntDef(0) / Distance) + 0.5);
      ModY = ModY + floor(DistanceY * (EditSpeedLY->Text.ToIntDef(0) / Distance) + 0.5);
    }
  }

  LabelOutput->Caption = "Object will be at   X: " + AnsiString(StartX+ModX)
     + "   Y: " + AnsiString(StartY+ModY) + "   in " + EditTime->Text + " year";

  if(EditTime->Text != 1)
    LabelOutput->Caption = LabelOutput->Caption + "s";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBoxStayOnTopClick(TObject *Sender)
{
  if(CheckBoxStayOnTop->Checked == true)
    Form1->FormStyle = fsStayOnTop;
  else
    Form1->FormStyle = fsNormal;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditObjectSpeedClick(TObject *Sender)
{
  WarpBoxFocus = true;
  EditObjectSpeedCover->Text = "";
  EditObjectSpeedCover->Visible = false;
  EditObjectSpeed->Visible = true;

  EditObjectSpeedChange(this);  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditObjectSpeedMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  WarpBoxFocus = true;
  EditObjectSpeedChange(this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpDown7MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if(floor(Warp + 0.99999) != floor(Warp))
    WarpBoxFocus = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditSpeedLYClick(TObject *Sender)
{
  WarpBoxFocus = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
  Form1->Canvas->MoveTo(ShapeA1->Left + ShapeA1->Width/2,ShapeA1->Top + ShapeA1->Height/2);
  Form1->Canvas->LineTo(ShapeB1->Left + ShapeB1->Width/2,ShapeB1->Top + ShapeB1->Height/2);

  Form1->Canvas->MoveTo(ShapeA2->Left + ShapeA2->Width/2,ShapeA2->Top + ShapeA2->Height/2);
  Form1->Canvas->LineTo(ShapeX2->Left + ShapeX2->Width/2,ShapeX2->Top + ShapeX2->Height/2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    FormGNU->Show();
}
//---------------------------------------------------------------------------

